--- Status: 18.07.2017


--- normalize format for project and branch names
SELECT
  REPLACE(project, '/', '_') as project,
  REPLACE(branch, '/', '_') as branch,
  default_branch,
  latest_commit,
  merge_base
FROM
  `project_sample.tr_sample_branches`;
=> project_sample.tr_sample_branches_tmp
=> project_sample.tr_sample_branches, delete tmp


--- search for duplicates in commits
SELECT
  project, branch, hash_value, author_name, author_email, author_date,
  commit_name, commit_email, commit_date, log_message_length,
  file_count, lines_added, lines_deleted, file_extensions
FROM
  `project_sample.tr_sample_commits`
GROUP BY
  project, branch, hash_value, author_name, author_email, author_date,
  commit_name, commit_email, commit_date, log_message_length,
  file_count, lines_added, lines_deleted, file_extensions; 
=> 20,160,666 (= number of records in tr_sample_commits)
=> no duplicates

SELECT
  project, branch, hash_value, merged_commits, author_name, author_email, author_date,
  commit_name, commit_email, commit_date, log_message_length,
  file_count, lines_added, lines_deleted, file_extensions,
  pull_request_id, source_user, source_branch
FROM
  `project_sample.tr_sample_merges`
GROUP BY
  project, branch, hash_value, merged_commits, author_name, author_email, author_date,
  commit_name, commit_email, commit_date, log_message_length,
  file_count, lines_added, lines_deleted, file_extensions,
  pull_request_id, source_user, source_branch;
=> 1,990,876 (= number of records in tr_sample_merges)
=> no duplicates


--- get most recent build date
SELECT MAX(tr_last_build) as tr_last_build
FROM `travistorrent.tr_projects`;
=> 2016-08-31T23:59:27


--- ignore all commit/merge activity after 2016-08-31
SELECT *
FROM `project_sample.tr_sample_commits`
WHERE DATE_DIFF(DATE("2016-08-31"), CAST(commit_date AS DATE), DAY) >= 0;
=> project_sample.tr_sample_commits_tmp
=> project_sample.tr_sample_commits, delete tmp

SELECT COUNT(*) FROM `project_sample.tr_sample_commits`;
=> 19,228,541

SELECT COUNT(DISTINCT hash_value) FROM `project_sample.tr_sample_commits`;
=> 860,699

SELECT *
FROM `project_sample.tr_sample_merges`
WHERE DATE_DIFF(DATE("2016-08-31"), CAST(commit_date AS DATE), DAY) >= 0;
=> project_sample.tr_sample_merges_tmp
=> project_sample.tr_sample_merges, delete tmp

SELECT COUNT(*) FROM `project_sample.tr_sample_merges`;
=> 1,990,876

SELECT COUNT(DISTINCT hash_value) FROM `project_sample.tr_sample_merges`;
=> 112,867
