
plot_data <- function(data, thresholds, filename, main, xlab) {
  pdf(filename, width=12, height=12)
  par(
    bg="white",
    #mar = c(1.2, 1.0, 0.1, 0.0)+0.1, # subplot margins (bottom, left, top, right)
    #omi = c(0.2, 0.5, 0.0, 0.0)+0.1,  # outer margins in inches (bottom, left, top, right)
    mfrow = c(1, 1),
    #pin = (width, height)
    #mfcol # draw in columns
    # increase font size
    cex=1.4,
    cex.main=1.4,
    cex.sub=1.4,
    cex.lab=1.2,
    cex.axis=1.2
  )
  #layout(matrix(c(1,2,3,4,5,5), 3, 2, byrow = TRUE))
  #layout(2, 1)
  
  # colors with alpha channel
  library(grDevices)
  gray_transparent <- adjustcolor("gray60", alpha.f=0.5)
  gray_lighter <- adjustcolor("gray85", alpha.f=1)
  gray_light <- adjustcolor("gray60", alpha.f=1)
  gray_dark <- adjustcolor("gray34", alpha.f=1)
  gray_darker <- adjustcolor("gray24", alpha.f=1)
  blue_light <- adjustcolor("skyblue1", alpha.f=1)
  blue_dark <- adjustcolor("steelblue4", alpha.f=1)
  red_light <- adjustcolor("salmon", alpha.f=1)
  red_dark <- adjustcolor("firebrick3", alpha.f=1)
  
  # histogram
  hist(data$ratio, 
       main=main, 
       freq=TRUE,
       xlab=xlab,
       ylab="Number of projects",
       border=gray_dark,
       col=gray_lighter,
       #labels=c(rep("", 10), "Selected"),
       xlim=c(0.0,1.0),
       ylim=c(0, 450),
       breaks=c(0.0,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0),
       xaxt="n",
       yaxt="n"
  )
  for (y in seq(50, 450, by=50)) {
    segments(x0=-0.5, y0=y, x1=0.9, y1=y, lty=1, lwd=1, col=gray_lighter)
  }
  segments(x0=-0.5, y0=0.0, x1=0.0, y1=0.0, lty=1, lwd=1, col=gray_lighter)
  library(beanplot)
  beanplot(data$ratio,
           add=TRUE,
           main="",
           ylim=c(0.0,1.0),
           what=c(0,1,0,0),
           border=gray_dark,
           log="",
           col=c(gray_transparent, gray_transparent, gray_transparent, gray_transparent),
           horizontal=TRUE,
           side="second",
           boxwex=1100,
           axes=FALSE
           #overallline="mean"
  )
  #abline(v=median(data_commits$ratio), lty=2, col="blue")
  if (thresholds$lower >= 0.0) {
    abline(v=thresholds$lower, lty=3, lwd=2, col=gray_dark) 
  }
  if (thresholds$upper <= 1.0) {
    abline(v=thresholds$upper, lty=3, lwd=2, col=gray_dark)  
  }
  boxplot(data$ratio,
          add=TRUE,
          outline=FALSE,
          horizontal=TRUE,
          ylim=c(0.0,1.0),
          log="",
          col="white",
          # https://stackoverflow.com/a/28890111
          lwd=2,
          medlwd=2,
          #staplelty=0,
          whisklty=1,
          #staplelty=0,
          whiskcol=gray_darker,
          medcol=gray_darker,
          boxcol=gray_darker,
          staplecol=gray_darker,
          boxwex=22,
          axes=FALSE
          #xaxt="n"
          #yaxt="n"
  )
  axis(1, at=seq(0.0, 1.0, by=0.1), labels=seq(0, 100, by=10))
  axis(2, at=seq(0, 450, by=50), labels=seq(0, 450, by=50), las=2)
  
  #par(mfrow = c(1, 1))
  dev.off()
}
